local AddonNam, AP = ...
AP.UI = {};
local UI = AP.UI;
local db = AP.db;
--local foundWin;
--local optionWin;

function UI:Show()
	UI.optionWin:SetShown(true);
	--UI:UpdateGraph();
end
function UI:Hide()
	UI.optionWin:SetShown(false);
end
function UI:Toggle()
	UI.optionWin:SetShown(not UI.optionWin:IsShown());
	--UI:UpdateGraph();
end
-- function UI:ShowOptions()
	-- UI:Debug("UI:Show");
	-- optionWin:SetShown(true);
-- end
-- function UI:HideOptions()
	-- UI:Debug("UI:Hide");
	-- optionWin:SetShown(false);
-- end
-- function UI:ToggleOptions()
	-- UI:Debug("UI:ToggleOptions");
	-- optionWin:SetShown(not optionWin:IsShown());
-- end

function UI:CreateOptionWindow() 
	
	local win = CreateFrame("Frame","SuperFLGOptions",UIParent,"BasicFrameTemplateWithInset");
	
	win:SetSize(400, 150);
	win:SetPoint("CENTER", UIParent, "CENTER") --, db.WindowOffsetX, db.WindowOffsetY)

	-- Window title
	win.title = win:CreateFontString(nil, "OVERLAY");
	win.title:SetFontObject("GameFontHighlight");
	win.title:SetPoint("LEFT", win.TitleBg, "LEFT", 5, 0);
	win.title:SetText("Super LFG");


	-- cb Keep searching
	win.cbKeepSearching = CreateFrame("CheckButton", nil, win, "UICheckButtonTemplate" );
	win.cbKeepSearching:SetPoint("TOPLEFT", win, "TOPLEFT", 10,-30);
	win.cbKeepSearching.text:SetText("Look for :");
	win.cbKeepSearching:SetNormalFontObject("GameFontNormalLarge")
	win.cbKeepSearching:SetChecked(AP.db.SearchEnabled);
	win.cbKeepSearching:SetScript("OnClick", function(self, arg1) 
					AP.db.SearchEnabled = self:GetChecked();
					UI.foundWin.cbKeepSearching:SetChecked(self:GetChecked());
				end);
			
	-- EditBox
	win.tbLookFor = CreateFrame("EditBox", nil, win, "InputBoxTemplate" );
	win.tbLookFor:SetPoint("CENTER", win, "CENTER");
	win.tbLookFor:SetText(AP.db.LookForText);
	win.tbLookFor:SetWidth(350);
	win.tbLookFor:SetHeight(100);
	win.tbLookFor:SetMovable(false);
	win.tbLookFor:SetAutoFocus(false);
	win.tbLookFor:SetMultiLine(false);
	win.tbLookFor:SetMaxLetters(32000);
	
	--Buttons
	-- win.closeBtn = CreateFrame("Button", nil, win, "GameMenuButtonTemplate" );
	-- win.closeBtn:SetSize(80, 30);
	-- win.closeBtn:SetPoint("BOTTOMLEFT", win, "BOTTOMLEFT", 10,10)
	-- win.closeBtn:SetText("Close");
	-- win.closeBtn:SetNormalFontObject("GameFontNormal");
	-- win.closeBtn:SetNormalFontObject("GameFontNormal");
	-- win.closeBtn:SetHighlightFontObject("GameFontHighlight");
	-- win.closeBtn:SetScript("OnClick", function(self, arg1) UI.optionWin:SetShown(false) end);
	
	win.saveBtn = CreateFrame("Button", nil, win, "GameMenuButtonTemplate" );
	win.saveBtn:SetSize(80, 30);
	win.saveBtn:SetPoint("BOTTOMRIGHT", win, "BOTTOMRIGHT", -10,10)
	win.saveBtn:SetText("Save");
	win.saveBtn:SetNormalFontObject("GameFontNormal");
	win.saveBtn:SetNormalFontObject("GameFontNormal");
	win.saveBtn:SetHighlightFontObject("GameFontHighlight");
	win.saveBtn:SetScript("OnClick", function(self, arg1) 
									AP.db.LookForText = win.tbLookFor:GetText()
									AP.db.SearchEnabled = win.cbKeepSearching:GetChecked()
									UI.optionWin:SetShown(false) 
									end);
	
	-- win:SetMovable(true)
	-- win:EnableMouse(true)
	-- win:RegisterForDrag("LeftButton")
	-- win:SetScript("OnDragStart", win.StartMoving)
	-- win:SetScript("OnDragStop", win.StopMovingOrSizing)
	win:SetMovable(true);
    win:EnableMouse(true);
	win:RegisterForDrag("LeftButton")
	win:SetScript("OnDragStart", win.StartMoving)
	win:SetScript("OnDragStop", win.StopMovingOrSizing)
	
	win:SetFrameLevel(2)
	--win:Hide();
	
	return win;
end

function UI:CreateFoundWindow() 
	
	local win = CreateFrame("Frame","SuperFLG",UIParent,"BasicFrameTemplateWithInset");
	
	win:SetSize(600, 200);
	win:SetPoint("CENTER", UIParent, "CENTER") --, db.WindowOffsetX, db.WindowOffsetY)

	-- Window title
	win.title = win:CreateFontString(nil, "OVERLAY");
	win.title:SetFontObject("GameFontHighlight");
	win.title:SetPoint("LEFT", win.TitleBg, "LEFT", 5, 0);
	win.title:SetText("Group found !");

	-- Player Found 
	win.lblPlayer = win:CreateFontString(nil, "OVERLAY");
	win.lblPlayer:SetFontObject("GameFontHighlightLarge");
	win.lblPlayer:SetPoint("TOPLEFT", win, "TOPLEFT", 20, -40);
	win.lblPlayer:SetText("Player");
	
	-- Text Found
	win.lblTextFound = win:CreateFontString(nil, "OVERLAY");
	win.lblTextFound:SetFontObject("GameFontHighlightLarge");
	win.lblTextFound:SetPoint("TOPLEFT", win, "TOPLEFT", 20, -60);
	win.lblTextFound:SetText("text");
	
	-- win.tbLookFor = CreateFrame("EditBox", nil, win, "InputBoxTemplate" );
	-- win.tbLookFor:SetPoint("CENTER", win, "CENTER");
	-- win.tbLookFor:SetText(AP.db.LookForText);
	-- win.tbLookFor:SetWidth(400);
	-- win.tbLookFor:SetHeight(400);
	-- win.tbLookFor:SetMovable(false);
	-- win.tbLookFor:SetAutoFocus(false);
	-- win.tbLookFor:SetMultiLine(false);
	-- win.tbLookFor:SetMaxLetters(32000);
	
	--Buttons
	win.closeBtn = CreateFrame("Button", nil, win, "GameMenuButtonTemplate" );
	win.closeBtn:SetSize(80, 30);
	win.closeBtn:SetPoint("BOTTOMRIGHT", win, "BOTTOMRIGHT", -10,10)
	win.closeBtn:SetText("Close");
	win.closeBtn:SetNormalFontObject("GameFontNormal");
	win.closeBtn:SetNormalFontObject("GameFontNormal");
	win.closeBtn:SetHighlightFontObject("GameFontHighlight");
	win.closeBtn:SetScript("OnClick", function(self, arg1) UI.foundWin:SetShown(false) end);
	
	
	-- cb Keep searching
	win.cbKeepSearching = CreateFrame("CheckButton", nil, win, "UICheckButtonTemplate" );
	win.cbKeepSearching:SetPoint("BOTTOMLEFT", win, "BOTTOMLEFT", 10,10);
	win.cbKeepSearching.text:SetText("Keep looking");
	win.cbKeepSearching:SetNormalFontObject("GameFontNormalLarge")
	win.cbKeepSearching:SetChecked(AP.db.SearchEnabled);
	win.cbKeepSearching:SetScript("OnClick", function(self, arg1) 
					AP.db.SearchEnabled = self:GetChecked();
					UI.optionWin.cbKeepSearching:SetChecked(self:GetChecked());
				end);
			
			
	-- win.saveBtn = CreateFrame("Button", nil, win, "GameMenuButtonTemplate" );
	-- win.saveBtn:SetSize(100, 30);
	-- win.saveBtn:SetPoint("BOTTOMRIGHT", win, "BOTTOMRIGHT", -10,10)
	-- win.saveBtn:SetText("Save");
	-- win.saveBtn:SetNormalFontObject("GameFontNormal");
	-- win.saveBtn:SetNormalFontObject("GameFontNormal");
	-- win.saveBtn:SetHighlightFontObject("GameFontHighlight");
	-- win.saveBtn:SetScript("OnClick", function(self, arg1) 
									-- AP.db.LookForText = win.tbLookFor:GetText()
									-- optionWin:SetShown(false) 
									-- end);
	
	-- win:SetMovable(true)
	-- win:EnableMouse(true)
	-- win:RegisterForDrag("LeftButton")
	-- win:SetScript("OnDragStart", win.StartMoving)
	-- win:SetScript("OnDragStop", win.StopMovingOrSizing)
	win:SetMovable(true);
    win:EnableMouse(true);
	win:RegisterForDrag("LeftButton")
	win:SetScript("OnDragStart", win.StartMoving)
	win:SetScript("OnDragStop", win.StopMovingOrSizing)
	
	win:SetFrameLevel(5)
	win:Hide();
	
	return win;
end

function UI:PopFound(text, playerName)
	UI.foundWin.lblPlayer:SetText(playerName .. " :");
	UI.foundWin.lblTextFound:SetText(text);
	UI.foundWin:SetShown(true)
	---PlaySound("LEVELUPSOUND", "master");
	--PlaySound(SOUNDKIT.IG_BACKPACK_CLOSE);
	PlaySound(SOUNDKIT.IG_PLAYER_INVITE);
end

function UI:Init()	
	----------
	UI.optionWin = self:CreateOptionWindow()
	UI.foundWin = self:CreateFoundWindow()
	
	-- optionWin = self:CreateOptionWindow()
	
	-- graph = self:InitGraph(mainWin)
	-- self:UpdateGraph()	

	----------
end