local AddonNam, AP = ...
local UI = AP.UI;
local App = LibStub("AceAddon-3.0"):NewAddon("SuperLFG", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

--------------------------------------
-- Custom Slash Command
--------------------------------------
local commands = {
	-- ["show"] = UI.Show, 
	-- ["hide"] = UI.Hide, 
	-- ["toggle"] = UI.Toggle, 
	-- ["options"] = UI.ShowOptions, 
	-- ["debug"] = function() 
		-- GV.debug = not GV.debug;
		-- if GV.debug == true then
			-- UI:Print("Debug on")
		-- else
			-- UI:Print("Debug off")	
		-- end			
		-- AP:CheckAllPlayerPoints();
		-- end, 	
	["help"] = function()
		print(" ");
		UI:Print("List of commands:");
		UI:Print("|cff00cc66/xpchart show|r - open Xp Chart window");
		UI:Print("|cff00cc66/xpchart hide|r - close Xp Chart window");
		UI:Print("|cff00cc66/xpchart toggle|r - toggle Xp Chart window");
		UI:Print("|cff00cc66/xpchart options|r - open Xp Chart options");
		UI:Print("|cff00cc66/xpchart help|r - shows help info");
		print(" ");
	end,
	
	-- ["example"] = {
		-- ["test"] = function(...)
			-- core:Print("My Value:", tostringall(...));
		-- end
	-- }
};
local function HandleSlashCommands(str)	
--print ("HandleSlashCommands");
	if (#str == 0) then	
		commands.help();
		return;		
	end	
	
	local args = {};
	for _, arg in ipairs({ string.split(' ', str) }) do
		if (#arg > 0) then
			table.insert(args, arg);
		end
	end	
	local path = commands; -- required for updating found table.
	for id, arg in ipairs(args) do
		if (#arg > 0) then -- if string length is greater than 0.
			arg = arg:lower();			
			if (path[arg]) then
				if (type(path[arg]) == "function") then				
					-- all remaining args passed to our function!
					path[arg](select(id + 1, unpack(args))); 
					return;					
				elseif (type(path[arg]) == "table") then				
					path = path[arg]; -- another sub-table found!
				end
			else
				-- does not exist!
				commands.help();
				return;
			end
		end
	end
end


function App:OnInitialize()
	
	
	SLASH_XpChart1 = "/slfg";
	SLASH_XpChart2 = "/superlfg";
	SlashCmdList.XpChart = HandleSlashCommands;
	 
	local LDB = LibStub("LibDataBroker-1.1", true)
	local LDBIcon = LDB and LibStub("LibDBIcon-1.0", true)
	if LDB then	
		local SLFG_MinimapBtn = LDB:NewDataObject("SuperLFG", {
			type = "launcher",
			text = "Super LFG",
			icon = "Interface\\AddOns\\SuperLFG\\logo",
			OnClick = function(_, button)
				if button == "LeftButton" then 
					UI.Toggle();
				elseif button == "RightButton" then
					UI.ToggleOptions();
				end
			end,
			OnTooltipShow = function(tt)
				tt:AddLine("Super LFG")
				tt:AddLine("|cffffff00Left click:|r Open Super LFG window")
				tt:AddLine("|cffffff00Right click:|r Open options window")
			end,
		})
		if LDBIcon then
			LDBIcon:Register("SuperLFG", SLFG_MinimapBtn, SuperLfgDB) -- PC_MinimapPos is a SavedVariable which is set to 90 as default
		end
	end
	
end
function App:OnEnable()

	AP.db = SuperLfgDB
	--print("App:OnInitialize " .. AP.db.LookForText)
		
		
	if AP.db == nil then
		AP.db = {}
	end
	if AP.db.SearchEnabled == nil then AP.db.SearchEnabled = true end
	if AP.db.LookForText == nil then AP.db.LookForText = ""	end
	if AP.db.WindowOffsetX == nil then AP.db.WindowOffsetX = 0 end
	if AP.db.WindowOffsetY == nil then AP.db.WindowOffsetY = 0 end
	
	UI:Init();

	
	-- self:RegisterEvent("TIME_PLAYED_MSG")
	
	-- self:RegisterEvent("CHAT_MSG_GUILD")
	-- self:RegisterEvent("CHAT_MSG_OFFICER")
	-- self:RegisterEvent("CHAT_MSG_BATTLEGROUND")
	-- self:RegisterEvent("CHAT_MSG_BATTLEGROUND_LEADER")
	-- self:RegisterEvent("CHAT_MSG_PARTY")
	-- self:RegisterEvent("CHAT_MSG_RAID_LEADER")
	-- self:RegisterEvent("CHAT_MSG_RAID")
	self:RegisterEvent("CHAT_MSG_WHISPER")
	-- self:RegisterEvent("CHAT_MSG_BN_WHISPER")
	self:RegisterEvent("CHAT_MSG_CHANNEL")
	-- self:RegisterEvent("CHAT_MSG_SAY")
	self:RegisterEvent("PLAYER_LOGOUT")
end

function App:PLAYER_LOGOUT(sender, args)
	--SuperLfgDB.WindowOffsetX = UI.mainWin
	--SuperLfgDB.WindowOffsetX = UI.mainWin
	--print ()
	SuperLfgDB = AP.db
end

-- https://wow.gamepedia.com/CHAT_MSG_CHANNEL

function App:CHAT_MSG_CHANNEL(sender, text, playerName, languageName, channelName, playerName2, specialFlags, zoneChannelID, channelIndex, channelBaseName, unused, lineID, guid, bnSenderID, isMobile, isSubtitle, hideSenderInLetterbox, supressRaidIcons)

-- print("text " ..  text)
-- print("playerName " ..  playerName)
-- print("languageName " ..  languageName)
-- print("channelName " ..  channelName)
-- print("playerName2 " ..  playerName2)
-- print("specialFlags " ..  specialFlags)
-- print("zoneChannelID " ..  zoneChannelID)
-- print("channelIndex " ..  channelIndex)
-- print("channelBaseName " ..  channelBaseName)
-- print("unused " ..  unused )
-- print("lineID " ..  lineID)
-- print("guid " ..  guid)
-- print("bnSenderID " ..  bnSenderID)
-- print("isMobile " ..  isMobile)
-- print("isSubtitle " ..  isSubtitle)
-- print("hideSenderInLetterbox " .. hideSenderInLetterbox)
-- print("supressRaidIcons " .. supressRaidIcons)
--CHAT_MSG_CHANNEL " .. args);
	checkMsg(text, playerName2)
end
function App:CHAT_MSG_WHISPER(sender, text, playerName, languageName, channelName, playerName2, specialFlags, zoneChannelID, channelIndex, channelBaseName, unused, lineID, guid, bnSenderID, isMobile, isSubtitle, hideSenderInLetterbox, supressRaidIcons)

-- print("text " ..  text)
-- print("playerName " ..  playerName)
-- print("languageName " ..  languageName)
-- print("channelName " ..  channelName)
-- print("playerName2 " ..  playerName2)
-- print("specialFlags " ..  specialFlags)
-- print("zoneChannelID " ..  zoneChannelID)
-- print("channelIndex " ..  channelIndex)
-- print("channelBaseName " ..  channelBaseName)
-- print("unused " ..  unused )
-- print("lineID " ..  lineID)
-- print("guid " ..  guid)
-- print("bnSenderID " ..  bnSenderID)
-- print("isMobile " ..  isMobile)
-- print("isSubtitle " ..  isSubtitle)
-- print("hideSenderInLetterbox " .. hideSenderInLetterbox)
-- print("supressRaidIcons " .. supressRaidIcons)
--CHAT_MSG_CHANNEL " .. args);

	checkMsg(text, playerName2)
end

function checkMsg(text, playerName)
	local found = false
	if AP.db.SearchEnabled == true then 
		local spl = split(AP.db.LookForText,";")
		for k,v in pairs(spl) do
			if string.match(string.lower(text) , string.lower(v)) then
				found = true 
			end			
		end
		if found == true then
			UI:PopFound(text, playerName)
		end
	end
end
function split(s, sep)
    local fields = {}

    local sep = sep or " "
    local pattern = string.format("([^%s]+)", sep)
    string.gsub(s, pattern, function(c) fields[#fields + 1] = c end)

    return fields
end


